Index: src/molecules.cpp
===================================================================
--- src/molecules.cpp	(revision 8c54a3b5f6bdf770309a91dff75fb62f47d91b6d)
+++ src/molecules.cpp	(revision 0dbddc24a89f547aa564634e7647f87ec8ce9700)
@@ -1029,176 +1555,351 @@
  * have to transform them).
  * This adds a new MD step to the config file.
+ * \param *out output stream for debugging
  * \param *file filename
+ * \param config structure with config::Deltat, config::IsAngstroem, config::DoConstrained
  * \param delta_t time step width in atomic units
  * \param IsAngstroem whether coordinates are in angstroem (true) or bohrradius (false)
+ * \param DoConstrained whether we perform a constrained (>0, target step in molecule::trajectories) or unconstrained (0) molecular dynamics, \sa molecule::MinimiseConstrainedPotential() 
  * \return true - file found and parsed, false - file not found or imparsable
- */
-bool molecule::VerletForceIntegration(char *file, double delta_t, bool IsAngstroem)
-{
-	element *runner = elemente->start;
-	atom *walker = NULL;
-	int AtomNo;
-	ifstream input(file);
-	string token;
-	stringstream item;
-	double a, IonMass;
-	ForceMatrix Force;
-	Vector tmpvector;
-
-	CountElements();	// make sure ElementsInMolecule is up to date
-
-	// check file
-	if (input == NULL) {
-		return false;
-	} else {
-		// parse file into ForceMatrix
-		if (!Force.ParseMatrix(file, 0,0,0)) {
-			cerr << "Could not parse Force Matrix file " << file << "." << endl;
-			return false;
-		}
-		if (Force.RowCounter[0] != AtomCount) {
-			cerr << "Mismatch between number of atoms in file " << Force.RowCounter[0] << " and in molecule " << AtomCount << "." << endl;
-			return false;
-		}
-		// correct Forces
-//		for(int d=0;d<NDIM;d++)
-//			tmpvector.x[d] = 0.;
-//		for(int i=0;i<AtomCount;i++)
-//			for(int d=0;d<NDIM;d++) {
-//				tmpvector.x[d] += Force.Matrix[0][i][d+5];
-//			}
-//		for(int i=0;i<AtomCount;i++)
-//			for(int d=0;d<NDIM;d++) {
-//				Force.Matrix[0][i][d+5] -= tmpvector.x[d]/(double)AtomCount;
-//			}
-		// and perform Verlet integration for each atom with position, velocity and force vector
-		runner = elemente->start;
-		while (runner->next != elemente->end) { // go through every element
-			runner = runner->next;
-			IonMass = runner->mass;
-			a = delta_t*0.5/IonMass;				// (F+F_old)/2m = a and thus: v = (F+F_old)/2m * t = (F + F_old) * a
-			if (ElementsInMolecule[runner->Z]) { // if this element got atoms
-				AtomNo = 0;
-				walker = start;
-				while (walker->next != end) { // go through every atom of this element
-					walker = walker->next;
-					if (walker->type == runner) { // if this atom fits to element
-						// check size of vectors
-						if (Trajectories[walker].R.size() <= (unsigned int)(MDSteps)) {
-							//cout << "Increasing size for trajectory array of " << *walker << " to " << (size+10) << "." << endl;
-							Trajectories[walker].R.resize(MDSteps+10);
-							Trajectories[walker].U.resize(MDSteps+10);
-							Trajectories[walker].F.resize(MDSteps+10);
-						}
-						// 1. calculate x(t+\delta t)
-						for (int d=0; d<NDIM; d++) {
-							Trajectories[walker].F.at(MDSteps).x[d] = -Force.Matrix[0][AtomNo][d+5];
-							Trajectories[walker].R.at(MDSteps).x[d] = Trajectories[walker].R.at(MDSteps-1).x[d];
-							Trajectories[walker].R.at(MDSteps).x[d] += delta_t*(Trajectories[walker].U.at(MDSteps-1).x[d]);
-							Trajectories[walker].R.at(MDSteps).x[d] += 0.5*delta_t*delta_t*(Trajectories[walker].F.at(MDSteps-1).x[d])/IonMass;		// F = m * a and s = 0.5 * F/m * t^2 = F * a * t
-						}
-						// 2. Calculate v(t+\delta t)
-						for (int d=0; d<NDIM; d++) {
-							Trajectories[walker].U.at(MDSteps).x[d] = Trajectories[walker].U.at(MDSteps-1).x[d];
-							Trajectories[walker].U.at(MDSteps).x[d] += 0.5*delta_t*(Trajectories[walker].F.at(MDSteps-1).x[d]+Trajectories[walker].F.at(MDSteps).x[d])/IonMass;
-						}
-//						cout << "Integrated position&velocity of step " << (MDSteps) << ": (";
-//						for (int d=0;d<NDIM;d++)
-//							cout << Trajectories[walker].R.at(MDSteps).x[d] << " ";					// next step
-//						cout << ")\t(";
-//						for (int d=0;d<NDIM;d++)
-//							cout << Trajectories[walker].U.at(MDSteps).x[d] << " ";					// next step
-//						cout << ")" << endl;
-						// next atom
-						AtomNo++;
-					}
-				}
-			}
-		}
-	}
-//	// correct velocities (rather momenta) so that center of mass remains motionless
-//	tmpvector.zero()
-//	IonMass = 0.;
-//	walker = start;
-//	while (walker->next != end) { // go through every atom
-//		walker = walker->next;
-//		IonMass += walker->type->mass;	// sum up total mass
-//		for(int d=0;d<NDIM;d++) {
-//			tmpvector.x[d] += Trajectories[walker].U.at(MDSteps).x[d]*walker->type->mass;
-//		}
-//	}
-//	walker = start;
-//	while (walker->next != end) { // go through every atom of this element
-//		walker = walker->next;
-//		for(int d=0;d<NDIM;d++) {
-//			Trajectories[walker].U.at(MDSteps).x[d] -= tmpvector.x[d]*walker->type->mass/IonMass;
-//		}
-//	}
-	MDSteps++;
-
-
-	// exit
-	return true;
-};
-
-/** Align all atoms in such a manner that given vector \a *n is along z axis.
+ * \todo This is not yet checked if it is correctly working with DoConstrained set to true.
+ */
+bool molecule::VerletForceIntegration(ofstream *out, char *file, config &configuration)
+{
+  atom *walker = NULL;
+  ifstream input(file);
+  string token;
+  stringstream item;
+  double IonMass, Vector[NDIM], ConstrainedPotentialEnergy, ActualTemp;
+  ForceMatrix Force;
+
+  CountElements();  // make sure ElementsInMolecule is up to date
+
+  // check file
+  if (input == NULL) {
+    return false;
+  } else {
+    // parse file into ForceMatrix
+    if (!Force.ParseMatrix(file, 0,0,0)) {
+      cerr << "Could not parse Force Matrix file " << file << "." << endl;
+      return false;
+    }
+    if (Force.RowCounter[0] != AtomCount) {
+      cerr << "Mismatch between number of atoms in file " << Force.RowCounter[0] << " and in molecule " << AtomCount << "." << endl;
+      return false;
+    }
+    // correct Forces
+    for(int d=0;d<NDIM;d++)
+      Vector[d] = 0.;
+    for(int i=0;i<AtomCount;i++)
+      for(int d=0;d<NDIM;d++) {
+        Vector[d] += Force.Matrix[0][i][d+5];
+      }
+    for(int i=0;i<AtomCount;i++)
+      for(int d=0;d<NDIM;d++) {
+        Force.Matrix[0][i][d+5] -= Vector[d]/(double)AtomCount;
+      }
+    // solve a constrained potential if we are meant to
+    if (configuration.DoConstrainedMD) {
+      // calculate forces and potential
+      atom **PermutationMap = NULL;
+      ConstrainedPotentialEnergy = MinimiseConstrainedPotential(out, PermutationMap,configuration.DoConstrainedMD, 0, configuration.GetIsAngstroem());
+      EvaluateConstrainedForces(out, configuration.DoConstrainedMD, 0, PermutationMap, &Force);
+      Free((void **)&PermutationMap, "molecule::MinimiseConstrainedPotential: *PermutationMap");
+    }
+    
+    // and perform Verlet integration for each atom with position, velocity and force vector
+    walker = start;
+    while (walker->next != end) { // go through every atom of this element
+      walker = walker->next;
+      //a = configuration.Deltat*0.5/walker->type->mass;        // (F+F_old)/2m = a and thus: v = (F+F_old)/2m * t = (F + F_old) * a
+      // check size of vectors
+      if (Trajectories[walker].R.size() <= (unsigned int)(MDSteps)) {
+        //out << "Increasing size for trajectory array of " << *walker << " to " << (size+10) << "." << endl;
+        Trajectories[walker].R.resize(MDSteps+10);
+        Trajectories[walker].U.resize(MDSteps+10);
+        Trajectories[walker].F.resize(MDSteps+10);
+      }
+      
+      // Update R (and F)
+      for (int d=0; d<NDIM; d++) {
+        Trajectories[walker].F.at(MDSteps).x[d] = -Force.Matrix[0][walker->nr][d+5]*(configuration.GetIsAngstroem() ? AtomicLengthToAngstroem : 1.);
+        Trajectories[walker].R.at(MDSteps).x[d] = Trajectories[walker].R.at(MDSteps-1).x[d];
+        Trajectories[walker].R.at(MDSteps).x[d] += configuration.Deltat*(Trajectories[walker].U.at(MDSteps-1).x[d]);     // s(t) = s(0) + v * deltat + 1/2 a * deltat^2 
+        Trajectories[walker].R.at(MDSteps).x[d] += 0.5*configuration.Deltat*configuration.Deltat*(Trajectories[walker].F.at(MDSteps).x[d]/walker->type->mass);     // F = m * a and s = 0.5 * F/m * t^2 = F * a * t
+      }
+      // Update U
+      for (int d=0; d<NDIM; d++) {
+        Trajectories[walker].U.at(MDSteps).x[d] = Trajectories[walker].U.at(MDSteps-1).x[d]; 
+        Trajectories[walker].U.at(MDSteps).x[d] += configuration.Deltat * (Trajectories[walker].F.at(MDSteps).x[d]+Trajectories[walker].F.at(MDSteps-1).x[d]/walker->type->mass); // v = F/m * t
+      }
+//      out << "Integrated position&velocity of step " << (MDSteps) << ": ("; 
+//      for (int d=0;d<NDIM;d++)
+//        out << Trajectories[walker].R.at(MDSteps).x[d] << " ";          // next step
+//      out << ")\t(";
+//      for (int d=0;d<NDIM;d++)
+//        cout << Trajectories[walker].U.at(MDSteps).x[d] << " ";          // next step
+//      out << ")" << endl;
+            // next atom
+    }
+  }
+  // correct velocities (rather momenta) so that center of mass remains motionless
+  for(int d=0;d<NDIM;d++)
+    Vector[d] = 0.;
+  IonMass = 0.;
+  walker = start;
+  while (walker->next != end) { // go through every atom
+    walker = walker->next;
+    IonMass += walker->type->mass;  // sum up total mass
+    for(int d=0;d<NDIM;d++) {
+      Vector[d] += Trajectories[walker].U.at(MDSteps).x[d]*walker->type->mass;
+    }
+  }
+  // correct velocities (rather momenta) so that center of mass remains motionless
+  for(int d=0;d<NDIM;d++)
+    Vector[d] /= IonMass;
+  ActualTemp = 0.;
+  walker = start;
+  while (walker->next != end) { // go through every atom of this element
+    walker = walker->next;
+    for(int d=0;d<NDIM;d++) {
+      Trajectories[walker].U.at(MDSteps).x[d] -= Vector[d];
+      ActualTemp += 0.5 * walker->type->mass * Trajectories[walker].U.at(MDSteps).x[d] * Trajectories[walker].U.at(MDSteps).x[d];
+    }
+  }
+  Thermostats(configuration, ActualTemp, Berendsen);
+  MDSteps++;
+
+
+  // exit
+  return true;
+};
+
+/** Implementation of various thermostats.
+ * All these thermostats apply an additional force which has the following forms:
+ * -# Woodcock
+ *  \f$p_i \rightarrow \sqrt{\frac{T_0}{T}} \cdot p_i\f$
+ * -# Gaussian
+ *  \f$ \frac{ \sum_i \frac{p_i}{m_i} \frac{\partial V}{\partial q_i}} {\sum_i \frac{p^2_i}{m_i}} \cdot p_i\f$
+ * -# Langevin
+ *  \f$p_{i,n} \rightarrow \sqrt{1-\alpha^2} p_{i,0} + \alpha p_r\f$  
+ * -# Berendsen
+ *  \f$p_i \rightarrow \left [ 1+ \frac{\delta t}{\tau_T} \left ( \frac{T_0}{T} \right ) \right ]^{\frac{1}{2}} \cdot p_i\f$
+ * -# Nose-Hoover
+ *  \f$\zeta p_i \f$ with \f$\frac{\partial \zeta}{\partial t} = \frac{1}{M_s} \left ( \sum^N_{i=1} \frac{p_i^2}{m_i} - g k_B T \right )\f$
+ * These Thermostats either simply rescale the velocities, thus this function should be called after ion velocities have been updated, and/or
+ * have a constraint force acting additionally on the ions. In the latter case, the ion speeds have to be modified
+ * belatedly and the constraint force set.
+ * \param *P Problem at hand
+ * \param i which of the thermostats to take: 0 - none, 1 - Woodcock, 2 - Gaussian, 3 - Langevin, 4 - Berendsen, 5 - Nose-Hoover
+ * \sa InitThermostat()
+ */
+void molecule::Thermostats(config &configuration, double ActualTemp, int Thermostat)
+{
+  double ekin = 0.;
+  double E = 0., G = 0.;
+  double delta_alpha = 0.;
+  double ScaleTempFactor;
+  double sigma;
+  double IonMass;
+  int d;
+  gsl_rng * r;
+  const gsl_rng_type * T;
+  double *U = NULL, *F = NULL, FConstraint[NDIM];
+  atom *walker = NULL;
+  
+  // calculate scale configuration
+  ScaleTempFactor = configuration.TargetTemp/ActualTemp;
+    
+  // differentating between the various thermostats
+  switch(Thermostat) {
+     case None:
+      cout << Verbose(2) <<  "Applying no thermostat..." << endl;
+      break;
+     case Woodcock:
+      if ((configuration.ScaleTempStep > 0) && ((MDSteps-1) % configuration.ScaleTempStep == 0)) {
+        cout << Verbose(2) <<  "Applying Woodcock thermostat..." << endl;
+        walker = start;
+        while (walker->next != end) { // go through every atom of this element
+          walker = walker->next;
+          IonMass = walker->type->mass;
+          U = Trajectories[walker].U.at(MDSteps).x;
+          if (walker->FixedIon == 0) // even FixedIon moves, only not by other's forces
+            for (d=0; d<NDIM; d++) {
+              U[d] *= sqrt(ScaleTempFactor);
+              ekin += 0.5*IonMass * U[d]*U[d];
+            }
+        }
+      }
+      break;
+     case Gaussian:
+      cout << Verbose(2) <<  "Applying Gaussian thermostat..." << endl;
+      walker = start;
+      while (walker->next != end) { // go through every atom of this element
+        walker = walker->next;
+        IonMass = walker->type->mass;
+        U = Trajectories[walker].U.at(MDSteps).x;
+        F = Trajectories[walker].F.at(MDSteps).x;
+        if (walker->FixedIon == 0) // even FixedIon moves, only not by other's forces
+          for (d=0; d<NDIM; d++) {
+            G += U[d] * F[d]; 
+            E += U[d]*U[d]*IonMass;
+          }
+      }
+      cout << Verbose(1) << "Gaussian Least Constraint constant is " << G/E << "." << endl;
+      walker = start;
+      while (walker->next != end) { // go through every atom of this element
+        walker = walker->next;
+        IonMass = walker->type->mass;
+        U = Trajectories[walker].U.at(MDSteps).x;
+        F = Trajectories[walker].F.at(MDSteps).x;
+        if (walker->FixedIon == 0) // even FixedIon moves, only not by other's forces
+          for (d=0; d<NDIM; d++) {
+            FConstraint[d] = (G/E) * (U[d]*IonMass);
+            U[d] += configuration.Deltat/IonMass * (FConstraint[d]);
+            ekin += IonMass * U[d]*U[d];
+          }
+      }
+      break;
+     case Langevin:
+      cout << Verbose(2) <<  "Applying Langevin thermostat..." << endl;
+      // init random number generator
+      gsl_rng_env_setup();
+      T = gsl_rng_default;
+      r = gsl_rng_alloc (T);
+      // Go through each ion
+      walker = start;
+      while (walker->next != end) { // go through every atom of this element
+        walker = walker->next;
+        IonMass = walker->type->mass;
+        sigma  = sqrt(configuration.TargetTemp/IonMass); // sigma = (k_b T)/m (Hartree/atomicmass = atomiclength/atomictime)
+        U = Trajectories[walker].U.at(MDSteps).x;
+        F = Trajectories[walker].F.at(MDSteps).x;
+        if (walker->FixedIon == 0) { // even FixedIon moves, only not by other's forces
+          // throw a dice to determine whether it gets hit by a heat bath particle
+          if (((((rand()/(double)RAND_MAX))*configuration.TempFrequency) < 1.)) {  
+            cout << Verbose(3) << "Particle " << *walker << " was hit (sigma " << sigma << "): " << sqrt(U[0]*U[0]+U[1]*U[1]+U[2]*U[2]) << " -> ";
+            // pick three random numbers from a Boltzmann distribution around the desired temperature T for each momenta axis
+            for (d=0; d<NDIM; d++) {
+              U[d] = gsl_ran_gaussian (r, sigma);
+            }
+            cout << sqrt(U[0]*U[0]+U[1]*U[1]+U[2]*U[2]) << endl;
+          }
+          for (d=0; d<NDIM; d++)
+            ekin += 0.5*IonMass * U[d]*U[d];
+        }
+      }
+      break;
+     case Berendsen:
+      cout << Verbose(2) <<  "Applying Berendsen-VanGunsteren thermostat..." << endl;
+      walker = start;
+      while (walker->next != end) { // go through every atom of this element
+        walker = walker->next;
+        IonMass = walker->type->mass;
+        U = Trajectories[walker].U.at(MDSteps).x;
+        F = Trajectories[walker].F.at(MDSteps).x;
+        if (walker->FixedIon == 0) { // even FixedIon moves, only not by other's forces
+          for (d=0; d<NDIM; d++) {
+            U[d] *= sqrt(1+(configuration.Deltat/configuration.TempFrequency)*(ScaleTempFactor-1));
+            ekin += 0.5*IonMass * U[d]*U[d];
+          }
+        }
+      }
+      break;
+     case NoseHoover:
+      cout << Verbose(2) <<  "Applying Nose-Hoover thermostat..." << endl;
+      // dynamically evolve alpha (the additional degree of freedom)
+      delta_alpha = 0.;
+      walker = start;
+      while (walker->next != end) { // go through every atom of this element
+        walker = walker->next;
+        IonMass = walker->type->mass;
+        U = Trajectories[walker].U.at(MDSteps).x;
+        if (walker->FixedIon == 0) { // even FixedIon moves, only not by other's forces
+          for (d=0; d<NDIM; d++) {
+            delta_alpha += U[d]*U[d]*IonMass;
+          }
+        }
+      }
+      delta_alpha = (delta_alpha - (3.*AtomCount+1.) * configuration.TargetTemp)/(configuration.HooverMass*Units2Electronmass);
+      configuration.alpha += delta_alpha*configuration.Deltat;
+      cout << Verbose(3) << "alpha = " << delta_alpha << " * " << configuration.Deltat << " = " << configuration.alpha << "." << endl;
+      // apply updated alpha as additional force
+      walker = start;
+      while (walker->next != end) { // go through every atom of this element
+        walker = walker->next;
+        IonMass = walker->type->mass;
+        U = Trajectories[walker].U.at(MDSteps).x;
+        if (walker->FixedIon == 0) { // even FixedIon moves, only not by other's forces
+          for (d=0; d<NDIM; d++) {
+              FConstraint[d] = - configuration.alpha * (U[d] * IonMass);
+              U[d] += configuration.Deltat/IonMass * (FConstraint[d]);
+              ekin += (0.5*IonMass) * U[d]*U[d];
+            }
+        }
+      }
+      break;
+  }    
+  cout << Verbose(1) << "Kinetic energy is " << ekin << "." << endl;
+};
+
+/** Align all atoms in such a manner that given vector \a *n is along z axis. 
  * \param n[] alignment vector.
  */
 void molecule::Align(Vector *n)
 {
-	atom *ptr = start;
-	double alpha, tmp;
-	Vector z_axis;
-	z_axis.x[0] = 0.;
-	z_axis.x[1] = 0.;
-	z_axis.x[2] = 1.;
-
-	// rotate on z-x plane
-	cout << Verbose(0) << "Begin of Aligning all atoms." << endl;
-	alpha = atan(-n->x[0]/n->x[2]);
-	cout << Verbose(1) << "Z-X-angle: " << alpha << " ... ";
-	while (ptr->next != end) {
-		ptr = ptr->next;
-		tmp = ptr->x.x[0];
-		ptr->x.x[0] =	cos(alpha) * tmp + sin(alpha) * ptr->x.x[2];
-		ptr->x.x[2] = -sin(alpha) * tmp + cos(alpha) * ptr->x.x[2];
-		for (int j=0;j<MDSteps;j++) {
-			tmp = Trajectories[ptr].R.at(j).x[0];
-			Trajectories[ptr].R.at(j).x[0] =	cos(alpha) * tmp + sin(alpha) * Trajectories[ptr].R.at(j).x[2];
-			Trajectories[ptr].R.at(j).x[2] = -sin(alpha) * tmp + cos(alpha) * Trajectories[ptr].R.at(j).x[2];
-		}
-	}
-	// rotate n vector
-	tmp = n->x[0];
-	n->x[0] =	cos(alpha) * tmp +	sin(alpha) * n->x[2];
-	n->x[2] = -sin(alpha) * tmp +	cos(alpha) * n->x[2];
-	cout << Verbose(1) << "alignment vector after first rotation: ";
-	n->Output((ofstream *)&cout);
-	cout << endl;
-
-	// rotate on z-y plane
-	ptr = start;
-	alpha = atan(-n->x[1]/n->x[2]);
-	cout << Verbose(1) << "Z-Y-angle: " << alpha << " ... ";
-	while (ptr->next != end) {
-		ptr = ptr->next;
-		tmp = ptr->x.x[1];
-		ptr->x.x[1] =	cos(alpha) * tmp + sin(alpha) * ptr->x.x[2];
-		ptr->x.x[2] = -sin(alpha) * tmp + cos(alpha) * ptr->x.x[2];
-		for (int j=0;j<MDSteps;j++) {
-			tmp = Trajectories[ptr].R.at(j).x[1];
-			Trajectories[ptr].R.at(j).x[1] =	cos(alpha) * tmp + sin(alpha) * Trajectories[ptr].R.at(j).x[2];
-			Trajectories[ptr].R.at(j).x[2] = -sin(alpha) * tmp + cos(alpha) * Trajectories[ptr].R.at(j).x[2];
-		}
-	}
-	// rotate n vector (for consistency check)
-	tmp = n->x[1];
-	n->x[1] =	cos(alpha) * tmp +	sin(alpha) * n->x[2];
-	n->x[2] = -sin(alpha) * tmp +	cos(alpha) * n->x[2];
-
-	cout << Verbose(1) << "alignment vector after second rotation: ";
-	n->Output((ofstream *)&cout);
-	cout << Verbose(1) << endl;
-	cout << Verbose(0) << "End of Aligning all atoms." << endl;
+  atom *ptr = start;
+  double alpha, tmp;
+  Vector z_axis;
+  z_axis.x[0] = 0.;
+  z_axis.x[1] = 0.;
+  z_axis.x[2] = 1.;
+
+  // rotate on z-x plane
+  cout << Verbose(0) << "Begin of Aligning all atoms." << endl;
+  alpha = atan(-n->x[0]/n->x[2]);
+  cout << Verbose(1) << "Z-X-angle: " << alpha << " ... ";
+  while (ptr->next != end) {
+    ptr = ptr->next;
+    tmp = ptr->x.x[0];
+    ptr->x.x[0] =  cos(alpha) * tmp + sin(alpha) * ptr->x.x[2];
+    ptr->x.x[2] = -sin(alpha) * tmp + cos(alpha) * ptr->x.x[2];
+    for (int j=0;j<MDSteps;j++) {
+      tmp = Trajectories[ptr].R.at(j).x[0];
+      Trajectories[ptr].R.at(j).x[0] =  cos(alpha) * tmp + sin(alpha) * Trajectories[ptr].R.at(j).x[2];
+      Trajectories[ptr].R.at(j).x[2] = -sin(alpha) * tmp + cos(alpha) * Trajectories[ptr].R.at(j).x[2];
+    }
+  }
+  // rotate n vector
+  tmp = n->x[0];
+  n->x[0] =  cos(alpha) * tmp +  sin(alpha) * n->x[2];
+  n->x[2] = -sin(alpha) * tmp +  cos(alpha) * n->x[2];
+  cout << Verbose(1) << "alignment vector after first rotation: ";
+  n->Output((ofstream *)&cout);
+  cout << endl;
+
+  // rotate on z-y plane
+  ptr = start;
+  alpha = atan(-n->x[1]/n->x[2]);
+  cout << Verbose(1) << "Z-Y-angle: " << alpha << " ... ";
+  while (ptr->next != end) {
+    ptr = ptr->next;
+    tmp = ptr->x.x[1];
+    ptr->x.x[1] =  cos(alpha) * tmp + sin(alpha) * ptr->x.x[2];
+    ptr->x.x[2] = -sin(alpha) * tmp + cos(alpha) * ptr->x.x[2];
+    for (int j=0;j<MDSteps;j++) {
+      tmp = Trajectories[ptr].R.at(j).x[1];
+      Trajectories[ptr].R.at(j).x[1] =  cos(alpha) * tmp + sin(alpha) * Trajectories[ptr].R.at(j).x[2];
+      Trajectories[ptr].R.at(j).x[2] = -sin(alpha) * tmp + cos(alpha) * Trajectories[ptr].R.at(j).x[2];
+    }
+  }
+  // rotate n vector (for consistency check)
+  tmp = n->x[1];
+  n->x[1] =  cos(alpha) * tmp +  sin(alpha) * n->x[2];
+  n->x[2] = -sin(alpha) * tmp +  cos(alpha) * n->x[2];
+
+  cout << Verbose(1) << "alignment vector after second rotation: ";
+  n->Output((ofstream *)&cout);
+  cout << Verbose(1) << endl;
+  cout << Verbose(0) << "End of Aligning all atoms." << endl;
 };
 
@@ -1209,12 +1910,13 @@
 bool molecule::RemoveAtom(atom *pointer)
 {
-	if (ElementsInMolecule[pointer->type->Z] != 0)	// this would indicate an error
-		ElementsInMolecule[pointer->type->Z]--;	// decrease number of atom of this element
-	else
-		cerr << "ERROR: Atom " << pointer->Name << " is of element " << pointer->type->Z << " but the entry in the table of the molecule is 0!" << endl;
-	if (ElementsInMolecule[pointer->type->Z] == 0)	// was last atom of this element?
-		ElementCount--;
-	Trajectories.erase(pointer);
-	return remove(pointer, start, end);
+  if (ElementsInMolecule[pointer->type->Z] != 0)  { // this would indicate an error
+    ElementsInMolecule[pointer->type->Z]--;  // decrease number of atom of this element
+    AtomCount--;
+  } else
+    cerr << "ERROR: Atom " << pointer->Name << " is of element " << pointer->type->Z << " but the entry in the table of the molecule is 0!" << endl;
+  if (ElementsInMolecule[pointer->type->Z] == 0)  // was last atom of this element?
+    ElementCount--;
+  Trajectories.erase(pointer);
+  return remove(pointer, start, end);
 };
 
@@ -1243,5 +1945,5 @@
 bool molecule::CleanupMolecule()
 {
-	return (cleanup(start,end) && cleanup(first,last));
+  return (cleanup(start,end) && cleanup(first,last));
 };
 
@@ -1250,13 +1952,13 @@
  * \return pointer to atom or NULL
  */
-atom * molecule::FindAtom(int Nr)	const{
-	atom * walker = find(&Nr, start,end);
-	if (walker != NULL) {
-		//cout << Verbose(0) << "Found Atom Nr. " << walker->nr << endl;
-		return walker;
-	} else {
-		cout << Verbose(0) << "Atom not found in list." << endl;
-		return NULL;
-	}
+atom * molecule::FindAtom(int Nr)  const{
+  atom * walker = find(&Nr, start,end);
+  if (walker != NULL) {
+    //cout << Verbose(0) << "Found Atom Nr. " << walker->nr << endl;
+    return walker;
+  } else {
+    cout << Verbose(0) << "Atom not found in list." << endl;
+    return NULL;
+  }
 };
 
@@ -1266,15 +1968,15 @@
 atom * molecule::AskAtom(string text)
 {
-	int No;
-	atom *ion = NULL;
-	do {
-		//cout << Verbose(0) << "============Atom list==========================" << endl;
-		//mol->Output((ofstream *)&cout);
-		//cout << Verbose(0) << "===============================================" << endl;
-		cout << Verbose(0) << text;
-		cin >> No;
-		ion = this->FindAtom(No);
-	} while (ion == NULL);
-	return ion;
+  int No;
+  atom *ion = NULL;
+  do {
+    //cout << Verbose(0) << "============Atom list==========================" << endl;
+    //mol->Output((ofstream *)&cout);
+    //cout << Verbose(0) << "===============================================" << endl;
+    cout << Verbose(0) << text;
+    cin >> No;
+    ion = this->FindAtom(No);
+  } while (ion == NULL);
+  return ion;
 };
 
@@ -1285,12 +1987,12 @@
 bool molecule::CheckBounds(const Vector *x) const
 {
-	bool result = true;
-	int j =-1;
-	for (int i=0;i<NDIM;i++) {
-		j += i+1;
-		result = result && ((x->x[i] >= 0) && (x->x[i] < cell_size[j]));
-	}
-	//return result;
-	return true; /// probably not gonna use the check no more
+  bool result = true;
+  int j =-1;
+  for (int i=0;i<NDIM;i++) {
+    j += i+1;
+    result = result && ((x->x[i] >= 0) && (x->x[i] < cell_size[j]));
+  }
+  //return result;
+  return true; /// probably not gonna use the check no more
 };
 
@@ -1302,30 +2004,30 @@
 double LeastSquareDistance (const gsl_vector * x, void * params)
 {
-	double res = 0, t;
-	Vector a,b,c,d;
-	struct lsq_params *par = (struct lsq_params *)params;
-	atom *ptr = par->mol->start;
-
-	// initialize vectors
-	a.x[0] = gsl_vector_get(x,0);
-	a.x[1] = gsl_vector_get(x,1);
-	a.x[2] = gsl_vector_get(x,2);
-	b.x[0] = gsl_vector_get(x,3);
-	b.x[1] = gsl_vector_get(x,4);
-	b.x[2] = gsl_vector_get(x,5);
-	// go through all atoms
-	while (ptr != par->mol->end) {
-		ptr = ptr->next;
-		if (ptr->type == ((struct lsq_params *)params)->type) { // for specific type
-			c.CopyVector(&ptr->x);	// copy vector to temporary one
-			c.SubtractVector(&a);	 // subtract offset vector
-			t = c.ScalarProduct(&b);					 // get direction parameter
-			d.CopyVector(&b);			 // and create vector
-			d.Scale(&t);
-			c.SubtractVector(&d);	 // ... yielding distance vector
-			res += d.ScalarProduct((const Vector *)&d);				// add squared distance
-		}
-	}
-	return res;
+  double res = 0, t;
+  Vector a,b,c,d;
+  struct lsq_params *par = (struct lsq_params *)params;
+  atom *ptr = par->mol->start;
+
+  // initialize vectors
+  a.x[0] = gsl_vector_get(x,0);
+  a.x[1] = gsl_vector_get(x,1);
+  a.x[2] = gsl_vector_get(x,2);
+  b.x[0] = gsl_vector_get(x,3);
+  b.x[1] = gsl_vector_get(x,4);
+  b.x[2] = gsl_vector_get(x,5);
+  // go through all atoms
+  while (ptr != par->mol->end) {
+    ptr = ptr->next;
+    if (ptr->type == ((struct lsq_params *)params)->type) { // for specific type
+      c.CopyVector(&ptr->x);  // copy vector to temporary one
+      c.SubtractVector(&a);   // subtract offset vector
+      t = c.ScalarProduct(&b);           // get direction parameter
+      d.CopyVector(&b);       // and create vector
+      d.Scale(&t);
+      c.SubtractVector(&d);   // ... yielding distance vector
+      res += d.ScalarProduct((const Vector *)&d);        // add squared distance
+    }
+  }
+  return res;
 };
 
@@ -1335,71 +2037,71 @@
 void molecule::GetAlignvector(struct lsq_params * par) const
 {
-		int np = 6;
-
-	 const gsl_multimin_fminimizer_type *T =
-		 gsl_multimin_fminimizer_nmsimplex;
-	 gsl_multimin_fminimizer *s = NULL;
-	 gsl_vector *ss;
-	 gsl_multimin_function minex_func;
-
-	 size_t iter = 0, i;
-	 int status;
-	 double size;
-
-	 /* Initial vertex size vector */
-	 ss = gsl_vector_alloc (np);
-
-	 /* Set all step sizes to 1 */
-	 gsl_vector_set_all (ss, 1.0);
-
-	 /* Starting point */
-	 par->x = gsl_vector_alloc (np);
-	 par->mol = this;
-
-	 gsl_vector_set (par->x, 0, 0.0);	// offset
-	 gsl_vector_set (par->x, 1, 0.0);
-	 gsl_vector_set (par->x, 2, 0.0);
-	 gsl_vector_set (par->x, 3, 0.0);	// direction
-	 gsl_vector_set (par->x, 4, 0.0);
-	 gsl_vector_set (par->x, 5, 1.0);
-
-	 /* Initialize method and iterate */
-	 minex_func.f = &LeastSquareDistance;
-	 minex_func.n = np;
-	 minex_func.params = (void *)par;
-
-	 s = gsl_multimin_fminimizer_alloc (T, np);
-	 gsl_multimin_fminimizer_set (s, &minex_func, par->x, ss);
-
-	 do
-		 {
-			 iter++;
-			 status = gsl_multimin_fminimizer_iterate(s);
-
-			 if (status)
-				 break;
-
-			 size = gsl_multimin_fminimizer_size (s);
-			 status = gsl_multimin_test_size (size, 1e-2);
-
-			 if (status == GSL_SUCCESS)
-				 {
-					 printf ("converged to minimum at\n");
-				 }
-
-			 printf ("%5d ", (int)iter);
-			 for (i = 0; i < (size_t)np; i++)
-				 {
-					 printf ("%10.3e ", gsl_vector_get (s->x, i));
-				 }
-			 printf ("f() = %7.3f size = %.3f\n", s->fval, size);
-		 }
-	 while (status == GSL_CONTINUE && iter < 100);
-
-	for (i=0;i<(size_t)np;i++)
-		gsl_vector_set(par->x, i, gsl_vector_get(s->x, i));
-	 //gsl_vector_free(par->x);
-	 gsl_vector_free(ss);
-	 gsl_multimin_fminimizer_free (s);
+    int np = 6;
+
+   const gsl_multimin_fminimizer_type *T =
+     gsl_multimin_fminimizer_nmsimplex;
+   gsl_multimin_fminimizer *s = NULL;
+   gsl_vector *ss;
+   gsl_multimin_function minex_func;
+
+   size_t iter = 0, i;
+   int status;
+   double size;
+
+   /* Initial vertex size vector */
+   ss = gsl_vector_alloc (np);
+
+   /* Set all step sizes to 1 */
+   gsl_vector_set_all (ss, 1.0);
+
+   /* Starting point */
+   par->x = gsl_vector_alloc (np);
+   par->mol = this;
+
+   gsl_vector_set (par->x, 0, 0.0);  // offset
+   gsl_vector_set (par->x, 1, 0.0);
+   gsl_vector_set (par->x, 2, 0.0);
+   gsl_vector_set (par->x, 3, 0.0);  // direction
+   gsl_vector_set (par->x, 4, 0.0);
+   gsl_vector_set (par->x, 5, 1.0);
+
+   /* Initialize method and iterate */
+   minex_func.f = &LeastSquareDistance;
+   minex_func.n = np;
+   minex_func.params = (void *)par;
+
+   s = gsl_multimin_fminimizer_alloc (T, np);
+   gsl_multimin_fminimizer_set (s, &minex_func, par->x, ss);
+
+   do
+     {
+       iter++;
+       status = gsl_multimin_fminimizer_iterate(s);
+
+       if (status)
+         break;
+
+       size = gsl_multimin_fminimizer_size (s);
+       status = gsl_multimin_test_size (size, 1e-2);
+
+       if (status == GSL_SUCCESS)
+         {
+           printf ("converged to minimum at\n");
+         }
+
+       printf ("%5d ", (int)iter);
+       for (i = 0; i < (size_t)np; i++)
+         {
+           printf ("%10.3e ", gsl_vector_get (s->x, i));
+         }
+       printf ("f() = %7.3f size = %.3f\n", s->fval, size);
+     }
+   while (status == GSL_CONTINUE && iter < 100);
+
+  for (i=0;i<(size_t)np;i++)
+    gsl_vector_set(par->x, i, gsl_vector_get(s->x, i));
+   //gsl_vector_free(par->x);
+   gsl_vector_free(ss);
+   gsl_multimin_fminimizer_free (s);
 };
 
